package rocks.zipcode.io.quiz4.fundamentals;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author leon on 11/12/2018.
 */
public class StringEvaluator {
    public static String[] getAllPrefixes(String string) {

        ArrayList<String> list = new ArrayList<>();
       for (int i = 0; i < string.length(); i++) {
             for (int j = string.length(); j > i; j--) {
                 if (!list.contains(string.substring(i, j))) {
                    list.add(string.substring(i, j));
                     }
              }
           }
       return list.toArray(new String[list.size()]);
    }

    public static String[] getCommonPrefixes(String string1, String string2) {
        List<String> result = new ArrayList<String>(Arrays.asList(getAllPrefixes(string1)));
       result.retainAll(Arrays.asList(getAllPrefixes(string2)));
       return result.toArray(new String[0]);


    }

    public static String getLargestCommonPrefix(String string1, String string2) {
        String[] newArray = getCommonPrefixes(string1,string2);
        String str = "";
         for (String s : newArray) {
            if (s.length() > str.length()) {
               str = s;
                }
           }
      return str;
    }
}
